<script lang="ts">
	import type { Reservation } from '$lib/types';
	import { getRoomStatusInt, getRoomTypeInt } from '$lib/utils';
	import { format } from 'date-fns';
	import Button from '../../../../components/Main/Button.svelte';
	import RoomImage from '../../../../components/Room/RoomImage.svelte';
	import ReservationStatusIcon from './ReservationStatusIcon.svelte';
	import fr from 'date-fns/locale/fr';
	import { updateReservationStatus } from '../../../api/reservation/reservation';
	import type { ReservationDB } from '../../../api/reservation/types';
	import ConfirmModal from '../../../../components/Main/ConfirmModal.svelte';
	import { getRoomPrice } from '$lib/room';
	import toast from 'svelte-french-toast';
	import { AlertCircleIcon, CheckCircleIcon, XCircleIcon } from 'svelte-feather-icons';
	import { checkIfAmountValid } from '../../../api/customer/customer';

	export let reservation: ReservationDB;

	$: console.log(reservation);

	const handleCancel = async () => {
		loading = true;
		await updateReservationStatus(reservation.reservationID.value, 2).then((res) => {
			console.log(res);
			if (res.success) {
				toast.success('Reservation annulée');
				setTimeout(() => {
					loading = false;
					showCancelModal = false;
					window.location.reload();
				}, 1000);
			} else {
				toast.error("Erreur lors de l'annulation de la reservation");
			}
		});
		loading = false;
	};

	const handleConfirm = async () => {
		loading = true;

		const enoughMoney = (
			await checkIfAmountValid(reservation.customerID.value, getRoomPrice(reservation.roomType) / 2)
		).success;

		if (!enoughMoney) {
			toast.error("Vous n'avez pas assez d'argent sur votre compte pour confirmer la reservation");
			setTimeout(() => {
				loading = false;
				showConfirmModal = false;
			}, 1000);
			return;
		}

		await updateReservationStatus(reservation.reservationID.value, 1).then((res) => {
			if (res.success) {
				toast.success('Reservation confirmée !');
				setTimeout(() => {
					loading = false;
					showConfirmModal = false;
					window.location.reload();
				}, 1000);
			} else {
				toast.error('Erreur lors de la confirmation de la reservation');
			}
		});
		loading = false;
	};

	$: isNotCancelled = reservation.status !== 2;

	let showConfirmModal = false;
	let showCancelModal = false;
	let loading = false;
</script>

<div class="border border-primary-500 rounded-xl flex flex-col w-full">
	<div class="relative h-20 w-full shadow-md">
		<RoomImage roomType={reservation.roomType} />
		<!-- <ReservationStatusIcon status={reservation.status} /> -->
	</div>
	<div
		class={'flex flex-col md:flex-row justify-around items-center gap-2 p-2 ' +
			(isNotCancelled ? 'border-b border-primary-500' : '')}
	>
		<span>Chambre: <span class="font-bold">{getRoomTypeInt(reservation.roomType)}</span></span>
		<span>
			{reservation.numberOfNights} nuit{reservation.numberOfNights > 1 ? 's' : ''}
		</span>
		<span
			>A partir du {format(new Date(reservation.checkInDate), 'dd MMM yyyy', { locale: fr })}</span
		>
	</div>
	<!-- <ReservationStatus status={reservation.status} /> -->
	<!-- <div class="flex justify-between items-center">
				<span>Status: {getRoomStatusInt(reservation.status)}</span>
			</div> -->
	<div
		class="relative bg-light-surface-600 w-full rounded-b-xl flex flex-col md:flex-row gap-2 md:gap-0 justify-between p-2"
	>
		<span
			class="bg-light-surface-500 special-round p-2 w-full md:w-1/3 font-semibold flex gap-2 text-primary-500"
		>
			<span class="flex items-center h-full">
				{#if reservation.status === 0}
					<AlertCircleIcon />
				{:else if reservation.status === 1}
					<CheckCircleIcon />
				{:else if reservation.status === 2}
					<XCircleIcon />
				{/if}
			</span>
			<span>
				{#if reservation.status === 0}
					Veuillez confirmer la reservation
				{:else if reservation.status === 1}
					Reservation confirmée
				{:else if reservation.status === 2}
					Reservation annulée
				{/if}
			</span>
		</span>

		{#if isNotCancelled}
			<div
				class="relative grow flex items-center justify-end px-4 text-white text-lg bouton rounded-r-xl"
			>
				<div class="flex justify-center md:justify-end w-full gap-2">
					<Button type="secondary" on:click={() => (showCancelModal = true)}
						>Annuler la reservation</Button
					>

					{#if reservation.status === 0}
						<Button on:click={() => (showConfirmModal = true)}>Confirmer la reservation</Button>
					{/if}
				</div>
			</div>
		{/if}
	</div>
	<!-- <div class="flex justify-end w-full gap-2 pt-4">
				<Button type="secondary" on:click={handleCancel}>Annuler la reservation</Button>

				{#if reservation.status === 1}
					<Button on:click={handleConfirm}>Confirmer la reservation</Button>
				{/if}
			</div> -->
</div>
<ConfirmModal title="Confirmation" bind:show={showConfirmModal} {loading} callback={handleConfirm}>
	<span>
		Vous aller confirmer la reservation. Les 50% restant du prix de la chambre vont être débité de
		votre compte. ({getRoomPrice(reservation.roomType) / 2}€)
	</span>
</ConfirmModal>

<ConfirmModal title="Annulation" bind:show={showCancelModal} {loading} callback={handleCancel}>
	<span>
		Vous aller annuler la reservation. Les montants déjà payés ne vous seront pas remboursés.
	</span>
</ConfirmModal>

<style>
	.special-round {
		border-radius: 0 40px 0.25rem 0.75rem;
	}
</style>
